// Die Zahlen (Hack....)

#define NUMBER_W 40

enum pressed_keys
{
	zahlenausgeben, clearscreen, reset, toggleMaxMin,
	left, right, up, down,
	CTRLleft, CTRLright, CTRLup, CTRLdown,
	doppeldick, sound, line
};

typedef struct
{
	int x,y;
	int off;
	int r,g,b;
}point;

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}
//10 zahlen, 8 hoch 5 breit: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, ., -, /, %, K
int zahl[8][15][5] =
{
	{{1,1,1,1,1}, {0,0,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,1}, {1,1,0,0,1}, {1,0,0,0,1}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,1,0}, {1,1,0,1,0}, {1,0,0,0,1}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,1,0}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,1,0}, {0,0,0,1,0}, {1,0,0,1,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,0}, {1,1,1,1,1}, {0,0,1,0,0}, {0,0,1,0,0}, {1,0,1,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,1,0,0}, {0,0,1,0,0}, {1,1,0,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}, {0,1,0,0,0}, {0,1,0,0,0}, {1,0,1,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,1,1}, {0,0,0,0,0}, {0,1,0,0,0}, {0,1,0,1,1}, {1,0,0,1,0}}, 
	{{1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,0}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,1}, {0,0,0,0,0}, {1,0,0,0,0}, {1,0,0,1,1}, {1,0,0,0,1}} 

//{,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, 

};

void Output(SDL_Surface *, char *, int, int, Uint32);

void Zahlenausgabe(SDL_Surface *screen, double y_stretch, double scale, int usedKoeffs, int currentFactor, double *factors, double *speed)
{
	int decimal, sign, x, y, i;
	char temp[20], sScale[20], sStretch[20], sUsedK_F[30], sKoeffF[20], sKoeffS[20], *buffer;
	SDL_Rect dest;
	Uint32 color = SDL_MapRGB(screen->format, 255, 255, 255);

	// scale
	buffer = _ecvt((scale/SCALE)*100, 5, &decimal, &sign );
	if (decimal<0) decimal =0; // okay, beschiss...
	strcpy(temp, buffer);
	temp[decimal]='.';
	strcpy(&temp[decimal+1], &buffer[decimal]);
	strcpy(sScale, " ");
	strcat(sScale, temp);
	strcat(sScale, " %");
	if (sign) sScale[0] = '-';

	// y_stretch in Prozent
	buffer = _ecvt(y_stretch, 5, &decimal, &sign );
	if (decimal<0) decimal =0; // okay, beschiss...
	strcpy(temp, buffer);
	temp[decimal]='.';
	strcpy(&temp[decimal+1], &buffer[decimal]);
	strcpy(sStretch, " ");
	strcat(sStretch, temp);
	if (sign) sStretch[0] = '-';

	// usedKoeffs + current
	itoa(currentFactor+1, temp, 10);
	strcpy(sUsedK_F, temp);
	strcat(sUsedK_F, " / ");
	itoa(usedKoeffs, temp, 10);
	strcat(sUsedK_F, temp);
	strcat(sUsedK_F, " K");

	dest.x = 30;	dest.y = screen->h - 35;	dest.h = 33;	dest.w = 200;
	SDL_FillRect(screen, &dest, 0);
	
	x=40;	y = screen->h - 30;
	Output(screen, sScale, x, y, color);
	x+=80;
	Output(screen, sStretch, x, y, color);
	x=40;	y += 15;
	Output(screen, sUsedK_F, x, y, color);

	// Koeff Factors + Speeds
	if (screen->w > 1020) // nicht ausgeben bei zu geringen Bildschirmbreite
	{
		dest.x = 1;	dest.y = 5;	dest.h = 76;	dest.w = screen->w;
		SDL_FillRect(screen, &dest, 0);

		for(i=0; i < usedKoeffs; i++)
		{
			buffer = _ecvt(factors[i], 5, &decimal, &sign );
			if (decimal<0) decimal =0; // okay, beschiss...
			strcpy(temp, buffer);
			temp[decimal]='.';
			strcpy(&temp[decimal+1], &buffer[decimal]);
			strcpy(sKoeffF, " ");
			strcat(sKoeffF, temp);
			if (sign) sKoeffF[0] = '-';

			buffer = _ecvt(speed[i], 5, &decimal, &sign );
			if (decimal<0) decimal =0; // okay, beschiss...
			strcpy(temp, buffer);
			temp[decimal]='.';
			strcpy(&temp[decimal+1], &buffer[decimal]);
			strcpy(sKoeffS, " ");
			strcat(sKoeffS, temp);
			if (sign) sKoeffS[0] = '-';

			if(i<25)
			{
				y = 10;
				x = 2 + i*NUMBER_W;

				if (currentFactor == i) color = SDL_MapRGB(screen->format, 255, 0, 0);
				else					color = SDL_MapRGB(screen->format, 255, 255, 255);

				Output(screen, sKoeffF, x, y, color);
				Output(screen, sKoeffS, x, y+15, color);
			}
			else
			{
				y = 50;
				x = 2 + (i%25)*NUMBER_W;

				if (currentFactor == i) color = SDL_MapRGB(screen->format, 255, 0, 0);
				else					color = SDL_MapRGB(screen->format, 255, 255, 255);

				Output(screen, sKoeffF, x, y, color);
				Output(screen, sKoeffS, x, y+15, color);
			}
		}
	}
}

void Output(SDL_Surface *screen, char *String, int xpos, int ypos, Uint32 color)
{
	int i,j,k,x;
	SDL_Rect dest;
	dest.x = xpos; dest.y = ypos;
	dest.y+=5;
	dest.x+=10;

	x=0;
	while (1)
	{
		switch (String[x])
		{
		case 0:		k=-1; break;
		case '0': 	k=0; break;
		case '1': 	k=1; break;
		case '2': 	k=2; break;
		case '3': 	k=3; break;
		case '4': 	k=4; break;
		case '5': 	k=5; break;
		case '6': 	k=6; break;
		case '7': 	k=7; break;
		case '8': 	k=8; break;
		case '9': 	k=9; break;
		case '.': 	k=10; break;
		case '-': 	k=11; break;
		case '/': 	k=12; break;
		case '%':	k=13; break;
		case 'K':	k=14; break;
		case ' ':
		default:	k=-2; break;
		}
		x++;
		if (k==-1) break;
		if (k==-2){ dest.x+=6;	continue; }

		for (i=0; i<8; i++)
		{
			for (j=0; j<5; j++)
			{
				if(zahl[i][k][j]) if ( (dest.y+i > 0) && (dest.y+i < screen->h) )putpixel(screen, dest.x+j, dest.y+i, color);
			}
		} //for i
		dest.x+=6;

	} //while
}